#include <iostream>
using std::cout;

struct G { };
struct A : G { };
struct B : A { };
struct C : B { };
struct D : G { };

template< typename T >
void foo( G, T ) { cout << "foo( G )\n"; }

namespace a {
    template< typename T >
    void foo( A, T ) { cout << "foo( A )\n"; }
    struct NA { };
    template< typename T >
    void bar( T ) { cout << "bar in a\n"; }

    namespace b {
        struct NB { };
        struct NBd : NA { };

        template< typename T >
        void foo( B, T ) { cout << "foo( B )\n"; }

        namespace c {
            template< typename T >
            void foo( C, T ) { cout << "foo( C )\n"; }
            template< typename T >
            void bar( T ) { cout << "bar in c\n"; }

            struct NC { };
            struct NCd : NBd { };
        } // namespace c
    } // namespace b
} // namespace a

namespace d {
    template< typename T >
    void foo( D, T ) { cout << "foo( D )\n"; }
    template< typename T >
    void bar( T ) { cout << "bar in d\n"; }
    template< typename T >
    void baz( T ) { cout << "baz in d\n"; }
    template< typename T >
    void meh( T ) { cout << "meh in d\n"; }

    struct ND { };
} // namespace d

namespace e {
    template< typename T >
    void baz( T ) { cout << "baz in e\n"; }
} // namespace e

template< typename T >
void meh( T ) { cout << "meh in global\n"; }

using namespace e;

struct Common : a::b::c::NCd, d::ND { };

#define OUT( X ) cout << #X ": "; X

int main() {
    OUT( foo( G(), 0 ) ); // G
    OUT( foo( A(), 0 ) ); // G
    OUT( foo( C(), 0 ) ); // G

    OUT( foo( A(), a::b::c::NC() ) ); // G
    OUT( foo( A(), a::b::c::NCd() ) ); // A

    OUT( foo( C(), a::b::c::NC() ) ); // G
    OUT( foo( C(), a::b::c::NCd() ) ); // C

    OUT( bar( d::ND() ) ); // D
    // OUT( bar( Common() ) ); // error

    OUT( baz( 0 ) ); // e
    // OUT( baz( Common() ) ); // error
}
