#include <iostream>
#include <string>

namespace People {

class Person {
	std::string name;

public:
	Person(std::string name) : name(std::move(name)) {}

	friend std::ostream& operator<<(std::ostream& out,
	                                const Person& person) {
		return out << "Person(\"" << person.name << "\")";
	}
};

//void f(const Person& /*person*/) {
//	std::cout << "f in namespace People\n";
//}

} // namespace People

//void f(const People::Person& /*person*/) {
//	std::cout << "f in global namespace\n";
//}

//template <typename T>
//void f(const T& /*unused*/) {
//	std::cout << "templated f in global namespace\n";
//}

int main() {
	People::Person summer("Summer Smith");
	std::cout << summer << '\n';
	// this is the same as calling:
	// operator<<(std::cout, summer);

	//f(summer);
}
