#include <iostream>

template <typename Self>
struct Eq {
private:
	const Self& self() const {
		return static_cast<const Self&>(*this);
	}

public:
	bool operator!=(const Self& other) const {
		return !(self() == other);
	}
};

struct Num : Eq<Num> {
	Num(int value) : value(value) {}
	int value;
	friend bool operator==(const Num& a, const Num& b) {
		return a.value == b.value;
	}
};

int main() {
	Num x = 10;
	Num y = 17;
	std::cout << std::boolalpha << (x != y) << '\n';
}
