#include <iostream>

// try uncommenting this and see what happens:
//int value = 42;

template< typename T >
struct Base {
	using value_type = T;
	value_type value{};
};

template< typename T >
struct Derived : Base< T > {
	// this won't compile:
	//value_type get();
	//Base< T >::value_type get();

	// this is OK:
	typename Base< T >::value_type get() { return {}; }

	void tell() const {
		// this won't compile (unless you uncomment the global
		// declaration of value above):
		//std::cout << value << '\n';

		// this is OK:
		std::cout << this->value << '\n';
	}
};

int main() {
	Derived<int> d;
	auto x = d.get();
	d.tell();
}
