#include <iostream>

struct Eq {};

template <typename T>
using IsEq = std::enable_if_t< std::is_base_of_v<Eq, T>, bool >;


template <typename T>
IsEq<T> operator!=(const T& a, const T& b) {
	return !(a == b);
}

struct Num : Eq {
	Num(int value) : value(value) {}
	int value;
	friend bool operator==(const Num& a, const Num& b) {
		return a.value == b.value;
	}
};

int main() {
	Num x = 10;
	Num y = 17;
	std::cout << std::boolalpha << (x != y) << '\n';
}
